
/** TP 5ETI - CPE Lyon - 2011/2012 */


#ifndef _SCENE_HPP_
#define _SCENE_HPP_

#include <matrix3.hpp>
#include <v3.hpp>
#include <mesh.hpp>

#include <vector>

class glwidget;

class scene
{
public:

    scene();

    void set_glwidget(glwidget *p_widget);

    /** \brief Method called only once at the beginning (load off files ...) */
    void load_model();
    /** \brief Method called at every frame */
    void draw_scene();

    bool is_grid;

    void draw_debug(cpe::mesh mesh_current);


    void set_is_debug_mode(bool);
    void set_is_debug_vertex_index(bool);
    void set_is_debug_face_index(bool);
    void set_is_debug_inverted_normal(bool);
    void set_is_debug_vertex_point(bool);

private:

    cpe::mesh mesh_0;
    std::vector<cpe::v3> mesh_0_normal;

    cpe::mesh mesh_1;
    std::vector<cpe::v3> mesh_1_normal;

    cpe::mesh mesh_plan;
    std::vector<cpe::v3> mesh_plan_normal;

    cpe::mesh my_mesh;
    std::vector<cpe::v3> my_mesh_normal;

    void creation_damier();
    void affichage_damier();

    bool is_debug_mode;
    bool is_debug_vertex_index;
    bool is_debug_face_index;
    bool is_debug_inverted_normal;
    bool is_debug_draw_vertex;
    void draw_index(const std::vector<cpe::v3>& x);
    void draw_index_face(const cpe::mesh& mesh,const std::vector<cpe::v3>& translate);
    glwidget *p_widget;
        cpe::mesh m;
        int counter;
};

#endif
