
#include <Qt/QtGui>
#include <window.hpp>
#include <glwidget.hpp>
#include <window_mesh_debug.hpp>

#include <ui_mainwindow.h>

#include <iostream>

Window::Window(QWidget *parent)
  :QMainWindow(parent),ui(new Ui::MainWindow)
{
  ui->setupUi(this);
  glWidget = new glwidget;
  ui->layout_scene->addWidget(glWidget);
  window_debug=new window_mesh_debug(this,glWidget);
 
  connect(ui->actionExit,SIGNAL(triggered()),this,SLOT(quit_window()));
  connect(ui->wireframe_checkbox,SIGNAL(stateChanged(int)),this,SLOT(set_wireframe(int)));
  connect(ui->debug_button,SIGNAL(clicked()),this,SLOT(debug_button_clicked()));
}

Window::~Window()
{
  if(ui!=0)
    {
      delete ui;
      ui=0;
    }
  if(window_debug!=0)
  {
      delete window_debug;
      window_debug=0;
  }
}

void Window::quit_window()
{
  std::cout<<"Exit window"<<std::endl;
  this->window()->close();
}

void Window::set_wireframe(int is_active)
{
    if(is_active==0)
        glWidget->set_filled();
    else
        glWidget->set_wireframe();
}
void Window::debug_button_clicked()
{
    window_debug->show();
}
